// header file for the PDP 11 code-generator  NOV 77

GET "LIBHDR"

MANIFEST
$(
//relocatable object blocks
T.HUNK=1000
T.RELOC=1001
T.END=1002
$)

MANIFEST $( SECWORD=12345 $)

MANIFEST
$(
// OCODE keywords
S.TRUE=4; S.FALSE=5
S.RV=8; S.FNAP=10
S.MULT=11; S.DIV=12; S.REM=13
S.PLUS=14; S.MINUS=15; S.QUERY=16; S.NEG=17; S.ABS=19
S.EQ=20; S.NE=21; S.LS=22; S.GR=23; S.LE=24; S.GE=25
S.NOT=30; S.LSHIFT=31; S.RSHIFT=32; S.LOGAND=33
S.LOGOR=34; S.EQV=35; S.NEQV=36
S.LP=40; S.LG=41; S.LN=42; S.LSTR=43; S.LL=44
S.LLP=45; S.LLG=46; S.LLL=47
S.NEEDS=48; S.SECTION=49
S.RTAP=51; S.GOTO=52
S.RETURN=67; S.FINISH=68
S.SWITCHON=70
S.GLOBAL=76
S.SP=80; S.SG=81; S.SL=82; S.STIND=83
S.JUMP=85; S.JT=86; S.JF=87; S.ENDFOR=88
S.LAB=90; S.STACK=91; S.STORE=92; S.RSTACK=93; S.ENTRY=94
S.SAVE=95; S.FNRN=96; S.RTRN=97; S.RES=98
S.DATALAB=100; S.ITEML=101; S.ITEMN=102
S.ENDPROC=103
S.DEBUG=109; S.NONE=111
S.GETBYTE=120; S.PUTBYTE=121
$)

// selectors
MANIFEST $( H1=0; H2=1; H3=2; H4=3  $)


GLOBAL $(

// global routines
CGSECTS:100
RDN:101
RDL:102
RDGN:103
NEXTPARAM:104
CHECKPARAM:105
CGERROR:106
INITSTACK:107
STACK:108
STORE:109
SCAN:110
CGPENDINGOP:111
CGGLOBCALL:112
NUMBERIS:113
GETVALUE:114
MOVETOANYRSH:115
MOVETOANYR:116
MOVETOR:117
LOOKINREGS:118
LOOKINFREEREGS:119
NEXTR:120
REGUSEDBY:121
ISFREE:122
FREEREG:123
STORET:124
LOADT:125
LOSE1:126
CGBYTEAP:127
CGSTIND:128
STOREIN:129
CGRV:130
CGSHIFTK:131
CGADDK:132
CGPLUS:133
CGMINUS:134
CGLOGAND:135
CGGLOBAL:136
CGENTRY:137
CGSAVE:138
CGAPPLY:139
CGRETURN:140
CGJUMP:141
CGCMP:142
CGSWITCH:143
BSWITCH:144
LSWITCH:145
CHECKBREFS:146
GENBREFJUMPS:147
BRLABREF:148
CONDBRFN:149
GENBRANCH:150
GENMOV:151
GENSD:152
GENRS:153
GENRD:154
GEND:155
GEN:156
GENJ:157
FORMSADDR:158
FORMDADDR:159
FORMADDR:160
REMEM:161
SETINFO:162
FORGET:163
FORGETVARS:164
FORGETALL:165
CODE:166
CODERAND:167
CODED:168
CODERS:169
CODESD:170
INSERTCOUNT:171
SETLAB:172
CGLAB:173
CGNAME:174
RAD50:175
CGSTRING:176
LABREF:177
CGDATA:178
CGSTATICS:179
INITDATALISTS:180
CHECKSPACE:181
OUTPUTSECTION:182
OBJWORD:183
RSXWORD:184
ENDRECORD:185
DBOUTPUT:186
WRKN:187


// global variables
ARG1:190
ARG2:191
PENDINGOP:192
OP:193
TEMPV:194
TEMPT:195
SSP:196
DLIST:197
DLISTE:198
REFLIST:199
REFLISTE:200
NEEDSLIST:201
NEEDSLISTE:202
STVP:203
STV:204
DP:205
PROGSIZE:206
REG.K:207
REG.N:208
MOVED:209
ADDR.M:210
ADDR.V:211
CASEK:212
CASEL:213
PARAMNUMBER:214
BREFV:215
BREFP:216
BREFT:217
LABV:218
INCODE:219
MAXGN:220
MAXLAB:221
MAXSSP:222
STKCHKING:223
PROCSTK:224
PROCSTKP:225
MAPPING:226
NAMING:227
CALLCOUNTING:228
PROFILE:229
COUNTFLAG:230
RESTRICTED:231
LISTING:232
BINING:233
RSXOBJ:234
OVERLAYING:235
DEBUGGING:236
GOSTREAM:237
OCODE:238
BINV:239
BINP:240
$)


MANIFEST
$(
// registers
R0=0; R1=1; R2=2; R3=3; R.G=4; R.P=5; R.SP=6; R.PC=7

// items in simulated stack, in registers, or
// arguments to GEN routines
K.NONE=1
K.NUMB=2
K.LOC=3; K.GLOB=4; K.LAB=5
K.MLOC=6; K.MGLOB=7; K.MLAB=8
K.LVLOC=9; K.LVGLOB=10; K.LVLAB=11
K.REG=12
K.X0=13; K.X1=14; K.X2=15; K.X3=16

// global routine numbers
GN.STOP=2
GN.CHECKSTK=3
GN.MULT=4
GN.DIV =5
GN.REM =6
GN.LSHIFT=7
GN.RSHIFT=8

// PDP addressing modes
M.V=#100; M.L=#200 // operand and label flags

M.10=#10           // indirect bit

M.20=#20; M.V27=#127; M.L27=#227; M.2P=#25; M.2S=#26

M.4P=#45

M.V60=#160; M.V6G=#164; M.V6P=#165; M.V67=#167; M.L67=#267
M.V70=#170; M.V7S=#176; M.L77=#277
$)

MANIFEST
$(
// single operand instructions
// compiled by GEND(F,K,N)
F.CLR = #05000
F.CLRB=#105000
F.DEC = #05300
F.INC = #05200
F.NEG = #05400
F.ADC = #05500
F.TST = #05700
F.COM = #05100
F.ASR = #06200
F.ASL = #06300
F.SXT = #06700
F.ROR = #06000
F.SWAB= #00300

// register source instructions
// compiled by GENRS(F,K,N)
F.ASH = #72000
F.ASHC= #73000
F.MUL = #70000
F.DIV = #71000

// register destination instructions
// compiled by GENRD(F,K,N)
F.XOR = #74000

// jump instructions
// compiled by GENJ(F,R,K,N)
F.JMP = #00100
F.JSR = #04000

// double operand instructions
// compiled by GENSD(F,K1,N1,K2,N2)
F.MOV = #10000
F.MOVB=#110000
F.ADD = #60000
F.SUB =#160000
F.CMP = #20000
F.BIS = #50000
F.BISB=#150000
F.BIT = #30000
F.BIC = #40000

// branch and condition code instructions
// compiled by GENBRANCH(F,L), GEN(F)
F.BR  = #00400   // this bit reverses a cond branch
F.BEQ = #01400
F.BNE = #01000
F.BLT = #02400
F.BGE = #02000
F.BLE = #03400
F.BGT = #03000

F.CLC = #00241
$)

