// This header file contains the interface between the standard
// BCPL compiler front end and its codegenerators.

/*
13/05/13
Extended to include globals used by bcpl64

05/01/11
Extended to include manifests and globals used by xbcpl and procode

*/


// MCPL lexical tokens, tree and MCODE operators


MANIFEST {     // Tokens and Parse Tree operators

s_eof=0
s_numb=1;	s_ln=1
s_vid=2
s_cid=3
s_string=4
s_true=5
s_false=6
s_query=7
s_tablab=8    // replacement for s_string and s_table

s_sbra=10;	s_lp=10
s_sket=11;	s_lg=11
s_rbra=12
s_rket=13;	s_llp=13
s_cbra=14;	s_llg=14
s_cket=15

s_comma=16;	s_sp=16
s_semicolon=17;	s_sg=17
s_colon=18;	s_lf=18
s_dot=19;	s_lx=19

s_lv=20
s_neg=21
s_abs=22
s_not=23
s_bitnot=24
s_vec=25
s_cvec=26
s_valof=27
s_table=28
s_ltable=29;	s_callc=29

s_call=30
s_indw=31
s_indw0=32
s_indb=33
s_indb0=34

s_lsh=35  // same order as op:= operators
s_rsh=36
s_mult=37
s_div=38
s_mod=39
s_bitand=40
s_xor=41
s_plus=42
s_sub=43
s_bitor=44

s_eq=45
s_ne=46
s_le=47
s_ge=48
s_ls=49
s_gr=50
s_rel=51
s_mthap=52

s_and=55
s_or=56

s_cond=58

s_ptr=59
s_dots=60;	s_ll=60
			s_lll=61
s_peq=62;	s_sl=62
s_pne=63;	s_lpath=63
s_ple=64;	s_llpath=64
s_pge=65;	s_spath=65
s_pls=66;	s_stw=66
s_pgr=67;	s_stb=67
			s_lvindw=68
			s_cpr=69
s_pass=70;	s_jt=70

s_plshass=71;	s_jf=71	// same order as the expression operator
s_prshass=72;	s_lab=72
s_pmultass=73;	s_stack=73
s_pdivass=74
s_pmodass=75
s_pandass=76
s_pxorass=77
s_pplusass=78
s_psubass=79;	s_dup=79
s_porass=80;	s_lr=80
				s_str=81
s_pand=82;		s_jump=82
s_por=83;		s_dlab=83
				s_dw=84
s_inc1=85;		s_db=85
s_inc4=86;		s_dl=86
s_dec1=87;		s_ds=87
s_dec4=88

s_inc1b=90
s_inc4b=91
s_dec1b=92
s_dec4b=93
s_inc1a=94
s_inc4a=95
s_dec1a=96
s_dec4a=97

s_let=100
s_scope=101
s_be=102
s_goto=103
s_raise=104
s_handle=105
s_test=106
s_then=107
s_else=108
s_if=109
s_unless=110
s_do=111
s_while=112
s_until=113
s_repeatwhile=114
s_repeatuntil=115
s_repeat=116
s_for=117
s_to=118
s_by=119
s_match=120
s_every=121
s_result=122
s_exit=123
s_return=124
s_break=125
s_loop=126
s_seq=127

s_ass=130

s_lshass=131   // same order as the expression operators
s_rshass=132
s_multass=133
s_divass=134
s_modass=135
s_andass=136
s_xorass=137
s_plusass=138
s_subass=139
s_orass=140

s_allass=141
s_all=142

s_module=145
s_get=146;		s_endmodule=146
s_external=147
s_static=148
s_manifest=149
s_global=150
s_fun=151
s_rarrow=152;	s_cfun=152
s_funpat=153;	s_endfun=153

s_sdef=154
s_mdef=155
s_gdef=156;		s_unhandle=156
s_xdef=157;		s_line=157

// Other MCODE operator(s)

s_file=158
s_setargs=159
s_fnargs=160
s_locs=161

s_none=200
}


MANIFEST {			//  Selectors
h1=0; h2=1; h3=2; h4=3; h5=4; h6=5; h7=6

}

MANIFEST {

nametablesize=256
charvupb=4095

c_backspace =  8
c_tab       =  9
c_newline   = 10
c_newpage   = 12
c_cr        = 13
c_escape    = 27
c_space     = 32
}


GLOBAL {			// Globals used in LEX
decval:201; getstreams:202; charv:203
readnumber:212; rdstrch:213
token:215; wordnode:216
rdtag:218; performget:219
lex:220; declsyswords:222; nlpending:223
lookup:225
skiptag:230; wrchbuf:231
rec_p:235; rec_l:236

					// GLOBALS USED IN SYN
rcom:246
nametable:248; nametablesize:249
synerr:251
rexplist:255; rdseq:256
rdplist:257
mk1:261; mk2:262; mk3:263
mk4:264; mk5:265; mk6:266; mk7:267
newvec:268
rnexp:271; rexp:272; rbexp:274

					// GLOBALS USED IN TRN
//fin_p:237; fin_l:238; findfilename:241

trnext:300; trans:301
findid:307
trnerr:311
jumpcond:320
transfor:322

preplhs:328
preplhsop:329
assign:330
assignall:331
assignop:332
load:333
loadlv:335
loadargs:336
isconst:337
evalconst:338
transvid:339
checkdistinct:340
outglobinits:341

nextlab:343; labnumber:344
newblk:346; retblk:348; retblks:349
wrc:350; mcount:351; wrn:353; wrpn:354

extlist:360
funlist:361
manlist:362
globlist:363; lastgn:364
statlist:365
sdlist:366
loclist:367
scopeptr:368
blklist:369

comline:370; procname:371
resultlab:372; defaultlab:373; exitlab:374
looplab:375; breaklab:376; ssp:377; nptr:378
outstring:380; out1:381; out2:382; out3:383; outline:384
matchpos:390; matchlen:391; matchlab:392
matchhdepth:393; rephdepth:394; valofhdepth:395; hdepth:396
}

GLOBAL {
//General Interface
errcount:600; errmax:601; fin_p:602; fin_l:603
sourcestream:604; sysprint:605; mcodeout:606
treep:607; treevec:608; findfilename:609

//Syn interface
chbuf:610; ch:611; chcount:612; lineno:613
rch:614; findfileno:615; filelist:616; freefilelist:617
formtree:618; plist:619

// Trn interface
translate:620

// Cg interface
mcodein:630; gostream: 631
codegenerate: 632
}


GLOBAL {
rdn:650

bigender         // Compiler options
naming
debug

gostream         // Stream for compiled code
}


MANIFEST {
cgg=700				// Start of codegenerator GLOBALs
}



