// BCPL-CG
// Header file for bcplcgint_i.b, the INTCODE generator for the 1-Feb-2011 BCPL compiler

GET "BCPL-cpl.h"
// from: "bcplfecg"

// This header file contains the interface between the standard
// BCPL compiler front end and its codegenerators.

/*
05/01/11
Extended to include manifests and globals used by xbcpl and procode

*/

MANIFEST $(
nametablesize=47
errmax=10
debug=0


// Interface globals are betweeb ug and feg-1
//ug=firstfreeglobal
//intg=ug		// First of the interface globals, ie those
				// common to Lex, Syn, Trn and the codegenerator.
//feg=intg+50	// First of the Lex/Syn globals
//trng=feg+60	// First of the TRN globals
cgg=400		// CG globals are cgg and above

//  Selectors
h1=0; h2=1; h3=2; h4=3; h5=4; h6=5

// BCPL lexical tokens, tree and ocode operators

// AE tree operators
s_number=1; s_name=2; s_string=3
s_valof=6; s_lv=7; s_vecap=9
s_byteap=28; s_mthap=29
s_cond=37; s_comma=38; s_table=39
s_and=40; s_valdef=41; s_vecdef=42
s_commalist=43; s_fndef=44; s_rtdef=45
s_ass=50; s_resultis=53; s_colon=54
s_test=55; s_for=56; s_if=57; s_unless=58
s_while=59; s_until=60; s_repeat=61
s_repeatwhile=62; s_repeatuntil=63
s_skip=64 // Added 22/6/05
s_loop=65; s_break=66
s_endcase=69; s_case=71; s_default=72
s_semicolonlist=73; s_seq=s_semicolonlist; s_let=74; s_manifest=75; s_static=79
s_semicolon=97

// AE tree and OCODE operators
s_true=4; s_false=5
s_rv=8; s_fnap=10
s_mult=11; s_div=12; s_rem=13; s_plus=14
s_minus=15; s_query=16; s_neg=17; s_abs=19
s_eq=20; s_ne=21; s_ls=22; s_gr=23; s_le=24; s_ge=25
s_slct=26; s_of=27                   // Inserted 11/7/01
s_not=30; s_lshift=31; s_rshift=32; s_logand=33
s_logor=34; s_eqv=35; s_neqv=36
s_needs=48; s_section=49
s_rtap=51; s_goto=52
s_return=67; s_finish=68
s_switchon=70; s_global=76

// Used in the code generators
s_none=99														// = M96

// OCODE operators
s_lp=40; s_lg=41; s_ln=42; s_lstr=43; s_ll=44
s_llp=45; s_llg=46; s_lll=47
s_local=77; s_label=78
s_sp=80; s_sg=81; s_sl=82; s_stind=83
s_jump=85; s_jt=86; s_jf=87; s_endfor=88
s_lab=90; s_stack=91; s_store=92; s_rstack=93
s_entry=94; s_save=95; s_fnrn=96; s_rtrn=97
s_res=98; s_datalab=100; s_iteml=101; s_itemn=102
s_endproc=103
s_constdef=104; s_const=105
s_lf=106
s_end=107; s_debug=108; s_char=109

s_getbyte=120; s_putbyte=121

// The following have been added for the extended compiler xbcpl
// Floating point operators and assignment operators, added 15/07/10

s_fnum=122 // Floating point constants							// = M132
s_float=123; s_fix=124; s_fabs=125
s_fmult=126; s_fdiv=127; s_fplus=128; s_fminus=129;  s_fpos=130; s_fneg=131
s_feq=132; s_fne=133; s_fls=134; s_fgr=135; s_fle=136; s_fge=137

// Assign operators -- added 15/07/10
s_assvecap=140													// = M148
s_assmult=141; s_assdiv=142; s_assrem=143; s_assplus=144; s_assminus=145
s_assfmult=146; s_assfdiv=147; s_assfplus=148; s_assfminus=149
s_asslshift=150; s_assrshift=151
s_asslogand=152; s_asslogor=153; s_asseqv=154; s_assneqv=155


s_selld=156; s_selst=157 // Added 19/07/10
/*
s_fltop =158	// FLTOP is followed by one of the fl_ codes	// = M166
				// eg FLTOP FPLUS to do a := b #+ a
				// or FLTOP FLOAT to do a := FLOAT a

sf_none=0		// Assignment operators
sf_vecap=1
sf_fmult=2
sf_fdiv=3
sf_fplus=4
sf_fminus=5
sf_mult=6
sf_div=7
sf_rem=8
sf_plus=9
sf_minus=10
sf_lshift=11
sf_rshift=12
sf_logand=13
sf_logor=14
sf_eqv=15
sf_neqv=16
*/
$)

GLOBAL $(
// Option variables, and fe-cg interface variables

fin_p:156
fin_l:157
treep:192
treevec:194

nametable:260

ssp:352
casek:363
casel:364

// Global CG procedures.
stv:400
stvp:401
maxlab:402
labnumber:403
reflist:404
cgerror:405
progsize:406
op:407
tempv:408
tempt:409
labv:410
labp:411
dp:412
labcheck:413
incode:414
linep:415
maxgn:416
maxssp:417
procdepth:418
info_a:419
info_b:420
initstack:421
initdatalists:422
codeb:423
coden:424
scan:425
codegenerate:426
outputsection:427
arg1:428
arg2:429
pendingop:430
// k_loc		// also a MANIFEST ???
// reflists		// not used
rlist:431
rliste:432
nlist:433
nliste:434
freelist:435
reflist:436
refliste:437

dboutput:440
state:441
load:442
storein:443
rdl:444
cgstring:445
opcode:446

force_nil:447
force_ad:448
force_ac:449
force_acad:450

code:451

ad_a:452
ad_k:453

complab:454
wrdata:455
data:456
$)

MANIFEST $(
m_n=0; m_i=1; m_p=2; m_ip=3; m_l=4; m_il=5; m_g=6; m_ig=7; m_f=8; m_if=9
f_l='L'; f_s='S'; f_a='A'; f_j='J'; f_t='T'; f_f='F'; f_k='K'; f_x='X'; f_w='W'
f_d='D'; f_c='C'
NIL=0; AD=1; AC=2; ACAD=3
$)

MANIFEST $( CONST_SIZE = 9500 $)			// Was originally 4000.  DC: 28-Nov-2012

MANIFEST $(
// Value descriptors.
k_none=0; k_numb=1; k_fnlab=2
k_lvloc=3; k_lvglob=4; k_lvlab=5
k_a=6; k_b=7; k_c=8
k_loc=9; k_glob=10; k_lab=11; 
k_loc0=12; k_loc1=13; k_loc2=14; k_loc3=15; k_loc4=16
k_glob0=17; k_glob1=18; k_glob2=19

swapped=TRUE; notswapped=FALSE

// Global routine numbers.
gn_stop=2
$)
