SECTION "cvsial"

GET "libhdr"

MANIFEST {   // sial opcodes and directives
f_1=      1  // Used in the run length encoding scheme
f_2=      2  // in compacted sial

f_lp=     3
f_lg=     4
f_ll=     5

f_llp=    6
f_llg=    7
f_lll=    8
f_lf=     9
f_lw=     10

f_l=      11
f_lm=     12

f_sp=     13
f_sg=     14
f_sl=     15

f_ap=     16
f_ag=     17
f_a=      18
f_s=      19

f_lkp=    20
f_lkg=    21
f_rv=     22
f_rvp=    23
f_rvk=    24
f_st=     25
f_stp=    26
f_stk=    27
f_stkp=   28
f_skg=    29
f_xst=    30

f_k=      31
f_kpg=    32

f_neg=    33
f_not=    34
f_abs=    35

f_xdiv=   36
f_xrem=   37
f_xsub=   38

f_mul=    39
f_div=    40
f_rem=    41
f_add=    42
f_sub=    43

f_eq=     44
f_ne=     45
f_ls=     46
f_gr=     47
f_le=     48
f_ge=     49
f_eq0=    50
f_ne0=    51
f_ls0=    52
f_gr0=    53
f_le0=    54
f_ge0=    55

f_lsh=    56
f_rsh=    57
f_and=    58
f_or=     59
f_xor=    60
f_eqv=    61

f_gbyt=   62
f_xgbyt=  63
f_pbyt=   64
f_xpbyt=  65

f_swb=    66
f_swl=    67

f_xch=    68
f_atb=    69
f_atc=    70
f_bta=    71
f_btc=    72
f_atblp=  73
f_atblg=  74
f_atbl=   75

f_j=      76
f_rtn=    77
f_goto=   78

f_ikp=    79
f_ikg=    80
f_ikl=    81
f_ip=     82
f_ig=     83
f_il=     84

f_jeq=    85
f_jne=    86
f_jls=    87
f_jgr=    88
f_jle=    89
f_jge=    90
f_jeq0=   91
f_jne0=   92
f_jls0=   93
f_jgr0=   94
f_jle0=   95
f_jge0=   96
f_jge0m=  97

f_brk=    98
f_nop=    99
f_chgco=  100
f_mdiv=   101
f_sys=    102

f_section=  103
f_modstart= 104
f_modend=   105
f_global=   106
f_string=   107
f_const=    108
f_static=   109
f_mlab=     110
f_lab=      111
f_lstr=     112
f_entry=    113

f_float=    114
f_fix=      115
f_fabs=     116
f_fmul=     117
f_fdiv=     118
f_fadd=     119
f_fsub=     120
f_fneg=     121

f_feq=      122
f_fne=      123
f_fls=      124
f_fgr=      125
f_fle=      126
f_fge=      127
}

GLOBAL $(
sialin:   200
asmout:   201
stdin:    202
stdout:   203

rdf:      210
rdp:      211
rdg:      212
rdk:      213
rdw:      215
rdl:      216
rdc:      218
rdcode:   219

pval:     220
gval:     221
kval:     222
wval:     224
lval:     225
mval:     226

scan:     230
cvf:      231
cvfp:     232
cvfg:     233
cvfk:     234
cvfw:     236
cvfl:     237

modname:  250
modletter:251
charv:    252
labnumber:253
$)

LET start() = VALOF
$( LET argv = VEC 20
   LET v    = VEC 20
   LET cv   = VEC 256/bytesperword

   modname := v
   modname%0 := 0
   modletter := 'A'
   charv := cv
   labnumber := 0

   asmout := 0
   stdout := output()
   IF rdargs("FROM,TO/K", argv, 20)=0 DO
   $( writes("Bad args for cvsial*n")
      RESULTIS 20
   $)
   IF argv!0=0 DO argv!0 := "SIAL"
   IF argv!1=0 DO argv!1 := "**"
   sialin := findinput(argv!0)
   IF sialin=0 DO
   $( writef("Trouble with file %s*n", argv!0)
      RESULTIS 20
   $)
   asmout := findoutput(argv!1)
   
   IF asmout=0 DO
   $( writef("Trouble with file %s*n", argv!1)
      RESULTIS 20
   $)
   
   selectinput(sialin)
   selectoutput(asmout)

   scan()
   endread()
   UNLESS asmout=stdout DO endwrite()
   selectoutput(stdout)

   RESULTIS 0
$)

AND nextlab() = VALOF
{ labnumber := labnumber+1
  RESULTIS labnumber
}

// argument may be of form Ln
AND rdcode(let) = VALOF
$( LET a, ch, neg = 0, ?, FALSE

   ch := rdch() REPEATWHILE ch='*s' | ch='*n'

   IF ch=endstreamch RESULTIS -1

   UNLESS ch=let DO error("Bad item, looking for %c found %c*n", let, ch)

   ch := rdch()

   IF ch='-' DO { neg := TRUE; ch := rdch() }

   WHILE '0'<=ch<='9' DO $( a := 10*a + ch - '0'; ch := rdch()  $)

   RESULTIS neg -> -a, a
$)

AND rdf() = rdcode('F')
AND rdp() = VALOF { pval := rdcode('P'); RESULTIS pval }
AND rdg() = VALOF { gval := rdcode('G'); RESULTIS gval }
AND rdk() = VALOF { kval := rdcode('K'); RESULTIS kval }
AND rdw() = VALOF { wval := rdcode('W'); RESULTIS wval }
AND rdl() = VALOF { lval := rdcode('L'); RESULTIS lval }
AND rdm() = VALOF { mval := rdcode('M'); RESULTIS mval }
AND rdc() = rdcode('C')

AND error(mess, a, b, c) BE
$( LET out = output()
   UNLESS out=stdout DO
   $( selectoutput(stdout)
      writef(mess, a, b, c)
      selectoutput(out)
   $)
   writef(mess, a, b, c)
$)

AND scan() BE
$( LET op = rdf()

   SWITCHON op INTO

   $( DEFAULT:       error("# Bad op %n*n", op); LOOP

      CASE -1:       RETURN
      
      CASE f_lp:     cvfp("LP") // a := P!n
                     ENDCASE

      CASE f_lg:     cvfg("LG") // a := G!n
                     ENDCASE

      CASE f_ll:     cvfl("LL") // a := !Ln
                     ENDCASE

      CASE f_llp:    cvfp("LLP") // a := @ P!n
                     ENDCASE

      CASE f_llg:    cvfg("LLG") // a := @ G!n
                     ENDCASE

      CASE f_lll:    cvfl("LLL") // a := @ !Ln
                     ENDCASE

      CASE f_lf:     cvfl("LF") // a := byte address of Ln
                     ENDCASE

      CASE f_lw:     cvfm("LW")
                     ENDCASE

      CASE f_l:      cvfk("L") // a := n
                     ENDCASE

      CASE f_lm:     cvfk("LM") // a := -n
                     ENDCASE

      CASE f_sp:     cvfp("SP") // P!n := a
                     ENDCASE

      CASE f_sg:     cvfg("SG") // G!n := a
                     ENDCASE

      CASE f_sl:     cvfl("SL") // !Ln := a
                     ENDCASE

      CASE f_ap:     cvfp("AP")		// a := a + P!n
                     ENDCASE

      CASE f_ag:     cvfg("AG") // a := a + G!n
                     ENDCASE

      CASE f_a:      cvfk("A") // a := a + n
                     ENDCASE
      CASE f_s:      cvfk("S")  // a := a - n
                     ENDCASE

      CASE f_lkp:    cvfkp("LKP") // a := P!n!k
                     ENDCASE

      CASE f_lkg:    cvfkg("LKG") // a := G!n!k
                     ENDCASE

      CASE f_rv:     cvf("RV")  // a := ! a
                     ENDCASE

      CASE f_rvp:    cvfp("RVP") // a := P!n!a
                     ENDCASE

      CASE f_rvk:    cvfk("RVK") // a := a!k
                     ENDCASE

      CASE f_st:     cvf("ST") // !a := b
                     ENDCASE

      CASE f_stp:    cvfp("STP") // P!n!a := b
                     ENDCASE

      CASE f_stk:    cvfk("STK") // a!n := b
                     ENDCASE

      CASE f_stkp:   cvfkp("STKP")  // P!n!k := a
                     ENDCASE

      CASE f_skg:    cvfkg("SKG") // G!n!k := a
                     ENDCASE

      CASE f_xst:    cvf("XST") // !b := a
                     ENDCASE

      CASE f_k:      cvfp("K") // Call  a(b,...) incrementing P by n
                     ENDCASE

      CASE f_kpg:    cvfpg("KPG") // Call Gg(a,...) incrementing P by n
                     ENDCASE

      CASE f_neg:    cvf("NEG") // a := - a
                     ENDCASE

      CASE f_not:    cvf("NOT") // a := ~ a
                     ENDCASE

      CASE f_abs:    cvf("ABS") // a := ABS a
                     ENDCASE

      CASE f_xdiv:   cvf("XDIV") // a := a / b
                     ENDCASE

      CASE f_xsub:   cvf("XSUB") // a := a - b
                     ENDCASE

      CASE f_mul:    cvf("MUL") // a := b * a; c := ?
                     ENDCASE

      CASE f_div:    cvf("DIV")  // a := b / a; c := ?
                     ENDCASE

      CASE f_rem:    cvf("REM") // a := b REM a; c := ?
                      ENDCASE

      CASE f_add:    cvf("ADD") // a := b + a
                     ENDCASE

      CASE f_sub:    cvf("SUB") // a := b - a
                     ENDCASE

      CASE f_eq:     cvf("EQ") // a := b = a
                     ENDCASE

      CASE f_ne:     cvf("NE") // a := b ~= a
                     ENDCASE

      CASE f_ls:     cvf("LS") // a := b < a
                     ENDCASE

      CASE f_gr:     cvf("GR") // a := b > a
                     ENDCASE

      CASE f_le:     cvf("LE") // a := b <= a
                     ENDCASE

      CASE f_ge:     cvf("GE") // a := b >= a
                     ENDCASE

      CASE f_eq0:    cvf("EQ0") // a := a = 0
                     ENDCASE

      CASE f_ne0:    cvf("NE0") // a := a ~= 0
                     ENDCASE

      CASE f_ls0:    cvf("LS0") // a := a < 0
                     ENDCASE

      CASE f_gr0:    cvf("GR0") // a := a > 0
                     ENDCASE

      CASE f_le0:    cvf("LE0") // a := a <= 0
                     ENDCASE

      CASE f_ge0:    cvf("GE0") // a := a >= 0
                     ENDCASE

      CASE f_lsh:    cvf("LSH") // a := b << a
                     ENDCASE

      CASE f_rsh:    cvf("RSH") // a := b >> a 
                     ENDCASE

      CASE f_and:    cvf("AND") // a := b & a 
                     ENDCASE

      CASE f_or:     cvf("OR") // a := b | a 
                     ENDCASE

      CASE f_xor:    cvf("XOR") // a := b XOR a
                     ENDCASE

      CASE f_eqv:    cvf("EQV") // a := b EQV a 
                     ENDCASE

      CASE f_gbyt:   cvf("GBYT") // a := b % a
                     ENDCASE

      CASE f_xgbyt:  cvf("XGBYT") // a := a % b 
                     ENDCASE

      CASE f_pbyt:   cvf("PBYT") // b % a := c
                     ENDCASE

      CASE f_xpbyt:  cvf("XPBYT") // a % b := c 
                     ENDCASE

// swb       Kn Ld K1 L1 ... Kn Ln   Binary chop switch, Ld default
      CASE f_swb:    cvswb()
                     ENDCASE

// swl       Kn Ld L1 ... Ln         Label vector switch, Ld default
      CASE f_swl:    cvswl()
                     ENDCASE

      CASE f_xch:    cvf("XCH") // swap a and b
                     ENDCASE

      CASE f_atb:    cvf("ATB") // b := a
                     ENDCASE

      CASE f_atc:    cvf("ATC") // c := a
                     ENDCASE

      CASE f_bta:    cvf("BTA") // a := b
                     ENDCASE

      CASE f_btc:    cvf("BTC") // c := b
                     ENDCASE

      CASE f_atblp:  cvfp("ATBLP") // b := a; a := P!n
                     ENDCASE

      CASE f_atblg:  cvfg("ATBLG") // b := a; a := G!n
                     ENDCASE

      CASE f_atbl:   cvfk("ATBL") // b := a; a := k
                     ENDCASE

      CASE f_j:      cvfl("J") // jump to Ln
                     ENDCASE

      CASE f_rtn:    cvf("RTN") // procedure return
                     ENDCASE

      CASE f_goto:   cvf("GOTO") // jump to a
                     ENDCASE

      CASE f_ikp:    cvfkp("IKP") // a := P!n + k; P!n := a
                     ENDCASE

      CASE f_ikg:    cvfkg("IKG") // a := G!n + k; G!n := a
                     ENDCASE

      CASE f_ikl:    cvfkl("IKL") // a := !Ln + k; !Ln := a
                     ENDCASE

      CASE f_ip:     cvfp("IP") // a := P!n + a; P!n := a
                     ENDCASE

      CASE f_ig:     cvfg("IG") // a := G!n + a; G!n := a
                     ENDCASE

      CASE f_il:     cvfl("IL") // a := !Ln + a; !Ln := a
                     ENDCASE

      CASE f_jeq:    cvfl("JEQ") // Jump to Ln if b = a
                     ENDCASE

      CASE f_jne:    cvfl("JNE") // Jump to Ln if b ~= a
                     ENDCASE

      CASE f_jls:    cvfl("JLS") // Jump to Ln if b < a
                     ENDCASE

      CASE f_jgr:    cvfl("JGR") // Jump to Ln if b > a
                     ENDCASE

      CASE f_jle:    cvfl("JLE") // Jump to Ln if b <= a
                     ENDCASE

      CASE f_jge:    cvfl("JGE") // Jump to Ln if b >= a
                     ENDCASE

      CASE f_jeq0:   cvfl("JEQ0") // Jump to Ln if a = 0
                     ENDCASE
      CASE f_jne0:   cvfl("JNE0") // Jump to Ln if a ~= 0
                     ENDCASE
      CASE f_jls0:   cvfl("JLS0") // Jump to Ln if a < 0
                     ENDCASE
      CASE f_jgr0:   cvfl("JGR0") // Jump to Ln if a > 0
                     ENDCASE
      CASE f_jle0:   cvfl("JLE0") // Jump to Ln if a <= 0
                     ENDCASE
      CASE f_jge0:   cvfl("JGE0") // Jump to Ln if a >= 0
                     ENDCASE

      CASE f_jge0m:  cvfm("JGE0M") // Jump to Mn if a >= 0
                     ENDCASE

      // The following five opcodes are never generated by
      // the BCPL compiler

      CASE f_brk:    cvf("BRK") // Breakpoint instruction
                     ENDCASE

      CASE f_nop:    cvf("NOP") // No operation
                     ENDCASE

      CASE f_chgco:  cvf("CHGCO") // Change coroutine
                     ENDCASE

      CASE f_mdiv:   cvf("MDIV") // a := Muldiv(P!3, P!4, P!5) 
                     ENDCASE

      CASE f_sys:    cvf("SYS") // System function
                     ENDCASE


      CASE f_section:  cvfs("SECTION") // Name of section
                       FOR i = 0 TO charv%0 DO modname%i := charv%i
                       ENDCASE

      CASE f_modstart: cvf("MODSTART") // Start of module  
                       modname%0 := 0
                       ENDCASE

      CASE f_modend:   cvf("MODEND") // End of module 
                       modletter := modletter+1
                       ENDCASE

      CASE f_global:   cvglobal() // Global initialisation data
                       ENDCASE

      CASE f_string: cvstring()		// String constant
                       ENDCASE

      CASE f_const:    cvconst() // Large integer constant
                       ENDCASE

      CASE f_static:   cvstatic() // Static variable or table
                       ENDCASE

      CASE f_mlab:     cvfm("MLAB") // Destination of jge0m
                       ENDCASE

      CASE f_lab:      cvfl("LAB") // Program label
                       ENDCASE

      CASE f_lstr:   cvfm("LSTR")	// a := Mn   (pointer to string)
                       ENDCASE

      CASE f_entry:    cventry() // Start of a function
                       ENDCASE

	//	Floating point ops added 8-September-2014:

      CASE f_float:    cvf("FLOAT")
                       ENDCASE
      CASE f_fix:      cvf("FIX") // a := #ABS a
                       ENDCASE

      CASE f_fabs:     cvf("FABS") // a := #ABS a
                       ENDCASE

      CASE f_fmul:     cvf("FMUL") // a := b #* a
                       ENDCASE

      CASE f_fdiv:     cvf("FDIV") // a := b #/ a
                       ENDCASE

      CASE f_fadd:     cvf("FADD") // a := b #+ a
                       ENDCASE

      CASE f_fsub:     cvf("FSUB") // a := b #- a
                       ENDCASE

      CASE f_fneg:     cvf("FNEG") // a := #- a
                       ENDCASE

      CASE f_feq:      cvf("FEQ")
                       ENDCASE

      CASE f_fne:      cvf("FNE")
                       ENDCASE

      CASE f_fls:      cvf("FLS")
                       ENDCASE

      CASE f_fgr:      cvf("FGR")
                       ENDCASE

      CASE f_fle:      cvf("FLE")
                       ENDCASE

      CASE f_fge:      cvf("FGE")
                       ENDCASE
   $)

   newline()
$) REPEAT

AND cvf(s)   BE writef("	%s", s)
AND cvfp(s)  BE writef("	%s	P%n", s, rdp())
AND cvfkp(s) BE writef("	%s	K%n P%n", s, rdk(), rdp())
AND cvfg(s)  BE writef("	%s	G%n", s, rdg())
AND cvfkg(s) BE writef("	%s	K%n G%n", s, rdk(), rdg())
AND cvfkl(s) BE writef("	%s	K%n L%n", s, rdk(), rdl())
AND cvfpg(s) BE writef("	%s	P%n G%n", s, rdp(), rdg())
AND cvfk(s)  BE writef("	%s	K%n", s, rdk())
AND cvfw(s)  BE writef("	%s	W%n", s, rdw())
AND cvfl(s)  BE
$( LET c1, c2, c3, lab = getbyte(s, 1), getbyte(s, 2), getbyte(s, 3), FALSE
   IF (c1='D' | c1='L') & NOT (c2='F' | c3='L') THEN lab := TRUE
   writef("%s%s	L%n", lab -> "", "*t", s, rdl())
$)
AND cvfm(s)  BE writef("	%s	M%n", s, rdm())

AND cvswb() BE
$( LET n = rdk()
   LET l = rdl()
   writef("	SWB K%n L%n", n, l)
   FOR i = 1 TO n DO 
   $( LET k = rdk()
      LET l = rdl()
      writef("*n	K%n L%n", k, l)
   $)
$)

AND cvglobal() BE
$( LET n = rdk()
   writef("GLOBAL K%n*n", n)
   IF modname%0=0 FOR i = 0 TO 4 DO modname%i := "prog"%i
   FOR i = 1 TO n DO
   $( LET g = rdg()
      LET n = rdl()
      writef("	G%n L%n*n", g, n)
   $)
   writef("	G%n", rdg())
$)

AND rdchars() = VALOF
{ LET n = rdk()
  charv%0 := n
  FOR i = 1 TO n DO charv%i := rdc()
  RESULTIS n
}

AND cvconst() BE
$( LET lab = rdm()
   LET w = rdw()
   writef("CONST   M%n W%n", lab, w)
$)

AND cvstatic() BE
$( LET lab = rdl()
   LET n = rdk()
   writef("	STATIC  L%n K%n", lab, n)
   FOR i = 1 TO n DO writef("*n	W%n", rdw())
$)

AND cvfs(s) BE
$( LET n = rdchars()
   writef("%s	K%n", s, n)
   FOR i = 1 TO n DO writef(" C%n", charv%i)
$)

AND cventry() BE
$( LET n = rdchars()
   LET op = rdf()
   LET lab = rdl()
   writef("*nEntry to: %s*n", charv)
   writef("%s	K%n", "ENTRY", n)
   FOR i = 1 TO n DO writef(" C%n", charv%i)
   newline()
   TEST op=f_lab THEN writef("LAB     L%n*n", lab)
                 ELSE writef("Bad op F%n L%n*n", op, lab)
$)

AND cvstring() BE
$( LET lab = rdm()
   LET n = rdchars()
   writef("	STRING  M%n K%n", lab, n); FOR i = 1 TO n DO writef(" C%n", charv%i)
$)

AND cvswl() BE
$( LET n = rdk()
   LET l = rdl()
   writef("	SWL K%n L%n", n, l)
   FOR i = 1 TO n DO
     writef("*n	L%n", rdl())
   newline()
$)


