 
// File BCPL1_TEST2SRC
 
// Test program for BCPL selectors
 
// Copyright R.D. Eager UKC   MCMLXXIX

GET "libhdr"
 
MANIFEST $(
byte0a  = SLCT 8:24:0
byte0b  = SLCT 0:24:0
byte2   = SLCT 8:8:0
byte3   = SLCT 8:0:0
byte4a  = SLCT 8:24:1
byte4b  = SLCT 0:24:1
byte9   = SLCT 8:16:2
f1      = SLCT 23:7:0
f2      = SLCT 17:2:1
e3      = SLCT 0:2:0
e4a     = SLCT 2:30:0
e7      = SLCT 2:0:2000
//	e9      = SLCT 2:0:262143
//	e10     = SLCT 2:0:-262144
w0      = SLCT 32:0:0
w1      = SLCT 32:0:1
w2      = SLCT 32:0:2
//	wm1     = SLCT 32:0:-1
//	wm2     = SLCT 0:0:-2
$)

STATIC $(
  testno	= 0
  testcount	= 0
  failcount	= 0
$)
 
LET t(x, y) = VALOF
$( testcount := testcount + 1
  writef("%i4 ", testno)
  writef("%i8	x%x8 ", x, x)
  TEST x=y
  THEN writes("OK")
  ELSE $( writef("x%x8", x); writes(" FAILED*nIt should be ")
         writef("%i8 x%x8", y, y)
         failcount := failcount + 1
       $)
  newline()
  testno := testno + 1
  RESULTIS y
$)

LET start() BE
$( LET a, b, c = ?, getvec(3000), ?
   FOR i=0 TO 3000 b!i := 0
   a, b!0, b!1, b!2, b!2000, c := 0, #xfedcba98, 1, 16, #x12345678, 2
   

  writef("*nSLCT code test:*n*n")
  testno := 0

   $( a := byte0a^b;	t(a, #xfe)				//	0
      byte0a^b := a;	t(byte0a^b, #xfe)
      a := byte0b^b;	t(a, #xfe)
      byte0b^b := a;	t(byte0b^b, #xfe)
      a := byte2^b;		t(a, #xba)
      byte2^b := a;		t(byte2^b, #xba)
      a := byte3^b;		t(a, #x98)
      byte3^b := a;		t(byte3^b, #x98)
      a := byte4a^b;	t(a, 0)
      byte4a^b := a;	t(byte4a^b, 0)
      a := byte4b^b;	t(a, 0)					//	10
      byte4b^b := a;	t(byte4b^b, 0)
      a := byte9^b;		t(a, 0)
      byte9^b := a;		t(byte9^b, 0)
      a := f1^b;		t(a, #x007DB975)
      f1^b := a;		t(f1^b, #x007DB975)
      a := f2^b;		t(a, 0)
      f2^b := a;		t(f2^b, 0)
      a := e3^b;		t(a, #x3FB72EA6)
      e3^b := a;		t(e3^b, #x3FB72EA6)
      a := e4a^b;		t(a, #x03)				//	20
      e4a^b := a;		t(e4a^b, #x03)
      a := e7^b;		t(a, 0)
      e7^b := a;		t(e7^b, 0)
    //a := e9^b
    //e9^b := a
    //a := e10^b
    //e10^b := a
    //e10::b := a
      w0^b := a;		t(w0^b, 0)
      a := w0^b;		t(a, 0)
      w1^b := a;		t(w1^b, 0)
      a := w1^b;		t(a, 0)
      w2^b := a;		t(w2^b, 0)
      a := w2^b;		t(a, 0)
    //wm1^a := b
    //a := wm1^b
    //wm2^a := b
    //a := wm2^b
   $)
 
   $( a := (SLCT 8:24:0)^b;		t(a, 0)			//	30
      (SLCT 8:24:0)^b := a;		t((SLCT 8:24:0)^b, 0)
      a := (SLCT 0:24:0)^b;		t(a, 0)
      (SLCT 0:24:0)^b := a;		t((SLCT 0:24:0)^b, 0)
      a := (SLCT 8:8:0)^b;		t(a, 0)
      (SLCT 8:8:0)^b := a;		t((SLCT 8:8:0)^b, 0)
      a := (SLCT 8:0:0)^b;		t(a, 0)
      (SLCT 8:0:0)^b := a;		t((SLCT 8:0:0)^b, 0)
      a := (SLCT 8:24:1)^b;		t(a, 0)
      (SLCT 8:24:1)^b := a;		t((SLCT 8:24:1)^b, 0)
      a := (SLCT 0:24:1)^b;		t(a, 0)			//	40
      (SLCT 0:24:1)^b := a;		t((SLCT 0:24:1)^b, 0)
      a := (SLCT 8:16:2)^b;		t(a, 0)
      (SLCT 8:16:2)^b := a;		t((SLCT 8:16:2)^b, 0)
      a := (SLCT 23:7:0)^b;		t(a, 0)
      (SLCT 23:7:0)^b := a;		t((SLCT 23:7:0)^b, 0)
      a := (SLCT 17:2:1)^b;		t(a, 0)
      (SLCT 17:2:1)^b := a;		t((SLCT 17:2:1)^b, 0)
      a := (SLCT 0:2:0)^b;		t(a, 0)
      (SLCT 0:2:0)^b := a;		t((SLCT 0:2:0)^b, 0)
      a := (SLCT 2:30:0)^b;		t(a, 0)			//	50
      (SLCT 2:30:0)^b := a;		t((SLCT 2:30:0)^b, 0)
      a := (SLCT 2:0:2000)^b;	t(a, 0)
      (SLCT 2:0:2000)^b := a;	t((SLCT 2:0:2000)^b, 0)
    //a := (SLCT 2:0:262143)^b
    //(SLCT 2:0:262143)^b := a
    //a := (SLCT 2:0:-262144)^b
    //(SLCT 2:0:-262144)^b := a
   $)
 
 
   $(
      c := b!0
      writef("...at end:  c=%n	x%x8*n", c, c)
      writef("*n%n tests completed of %n	(%n failures)*n*n", testcount, testno, failcount)

   $)
$)
 
// End of file BCPL1_TEST2SRC	(from Bob Eager's ICL 2900 test utilities)
