@echo off

rem Make script for BCPLkit

setlocal enabledelayedexpansion
if errorlevel 1 (
  echo Unable to enable delayed expansion - aborting!
  goto eof
)

if not defined BCPLenv (
  echo The BCPL environment is not defined.  Please 'cd' to the
  echo 	BCPLkit-0.9.7 directory and run 'BCPLenv'
  goto eof
)

rem Initialize

rem	Operating System			Version Number	Other Information
rem	Windows 1.0					1.04
rem	Windows 2.0					2.11
rem	Windows 3.0					3
rem	Windows NT 3.1				3.10.528
rem	Windows for Workgroups 		3.11		3.11
rem	Windows NT Workstation 		3.5		3.5.807
rem	Windows NT Workstation 		3.51		3.51.1057
rem	Windows 95					4.0.950
rem	Windows NT Workstation 		4.0		4.0.1381
rem	Windows 98					4.1.1998
rem	Windows 98 Second Edition	4.1.2222
rem	Windows Me					4.90.3000
rem	Windows 2000 Professional	5.0.2195
rem	Windows XP					5.1.2600	Current SP3
rem	Windows XP Professional x64 Edition		5.2.3790
rem	Windows Vista				6.0.6000	Current Version changed to 6.0.6002 with SP2
rem	Windows 7					6.1.7600	RTM
rem	Windows 8					6.2.(????)
rem	Windows Server 2012 R2		6.3.(????)
rem	Windows 8.1					6.3.(????)
rem	Windows 10					10.0.(????)

rem	Check Windows Version...

for /f "usebackq tokens=*" %%i in (`ver`) do set w_vn=%%i
echo %w_vn% | findstr "5\.1\." > nul
if %errorlevel% equ 0 set m_vn=XP
echo %w_vn% | findstr "6\.1\." > nul
if %errorlevel% equ 0 set m_vn=W7
echo %w_vn% | findstr "10\.0\." > nul
if %errorlevel% equ 0 set m_vn=WX

if not defined m_vn (
	echo.
	echo 	This version of %w_vn% isn't supported!
	echo.
	goto eof
)

rem	go to parent directory...
cd ..
set home=%cd%
echo 	%home%

set fn=BCPLmakelist.txt

if [%1]==[-h] (
  echo	Usage:	%0 [-Options] ^| [[make_directive] [sub-specifier]]
  echo		where	[-Options] may be any of:
  echo			[-h] this help text
  echo			[-l] list the compilers in '..\BCPLmakelist.txt'
  echo.
  echo			[make_directive] ^(optional^) is passed to 'Make'...
  echo			...and may be, eg: 'all', 'tidy', 'clean', etc
  echo.
  echo			[sub-specifier] may be text in '..\BCPLmakelist.txt'
  echo			uniquely identifying a ^(group of^) compilers to be
  echo			built/tidied/cleaned, etc
  echo.
  goto done
)

if [%1]==[-l] (
  echo.
  echo BCPL compilers in this distribution:
  echo.
  for /f "tokens=1,*" %%i in (%fn%) do if %%i==# (
	if [%%j]==[] (
	  echo.
	) else (
	  echo 	%%j
	)
  )
  goto done
)

set MAKE=make

rem	for %%i in ("copt" "BCPLkit-0.9.7\src" "BCPLkit-0.9.7\util" "BCPL 2006-06-16" "BCPL 2006-06-16\codegens" "BCPL 1979-09-01" "BCPL 1979-09-01\codegens" "BCPL 1979-09-01\util" "BCPL 2014-08-13" "BCPL 1968-06-19" "BCPL 1968-06-19\codegens" "BCPL 1968-06-19\BCPL-CTSS" "BCPL 1968-06-19\util" "BCPL 1980-03-10" "BCPL 1980-03-10\codegens" "BCPL 1980-03-10\src" "BCPL 1980-03-10\util" "BCPL 1980-03-10\BCPL-Alto" "BCPL 1980-03-10\BCPL-Alto\util" "BCPL 2006-06-16\ng_codegens" "BCPL 2006-06-16\util" "X-BCPL 2013-05-17" "BCPL 1981-03-05" "BCPL 1981-03-05\util" "BCPL 2014-08-13\codegens" "BCPL 2014-08-13\util" "BCPL 2014-08-13\sial" "BCPL 2014-08-13\sial\util" "BCPL 2014-08-13\mial" "BCPL 2014-08-13\mcpl" "BCPL 2014-08-13\mcpl\util" "BCPL 2020-05-13" "BCPL 2020-05-13\codegens" "BCPL 2020-05-13\util") do (

rem The list in '..\BCPLmakelist.txt' enumerates the set of directories in this distribution - THE ORDER IN THAT LIST IS SIGNIFICANT!

if [%~2]==[] goto all
  
set fn=BCPLmakelist%random%.txt
grep "%2" BCPLmakelist.txt > %fn%

:all
set dir=

for /f "eol=# tokens=*" %%i in (%fn%) do (
  set dlist=%%i
  rem echo 	dlist=!dlist!
  for %%j in (!dlist!) do (
	if exist %%j (
	  set dir=%%j
	  echo.
	  echo 	________ !dir! _________
	  cd %home%\!dir!
	  if exist #* (
		echo.
		for /f "usebackq delims==" %%k IN (`dir /b #*`) DO @echo %%k
		echo.
		sleep 2
	  )
rem	  sleep 1
	  %MAKE% %1
	  cd %home%
	)
  )
)


:done

cd %home%
if not [%fn%]==[BCPLmakelist.txt] if exist %fn% del /q %fn% > nul

echo.
:eof


