// $Id: iolib.b,v 1.1 2014/06/02 17:36:37 rn Exp $

// SECTION "IOLIB"

/*	This module presents a set of minimalist routines and functions to
 *	satisfy the requirements of BCPL compilers and programs written for
 *	the IBM 360/370 implementations - an alternative to rewriting the
 *	programs themselves...
 *	
 *	It is most easily included in those programs by the addition of the
 *	line:
 *		GET "iolib.b"
 *	near the head of the file.
 */

GET "iohdr.h"

LET FINDPARM() = FINDINPUT("params")

LET WRITELOG(FORMAT, A, B, C, D, E, F, G, H, I, J, K) BE
$(	LET OS=OUTPUT()
	SELECTOUTPUT(SYSERR)
	WRITEF(FORMAT, A, B, C, D, E, F, G, H, I, J, K)
	SELECTOUTPUT(OS)	$)

LET UNLOAD(SEG) BE RETURN

LET LOAD(SEG) BE RETURN

/*	NB:		'rtc.s' now includes 'time()', returning the ticks since the epoch...
 *
 *	LET TIME() = 0
 */

LET SKIPREC() BE RETURN

LET WRITEREC(V, SIZE) BE
/*	Write a record of |N| characters to the COS from words V!0
 *	onwards, the characters being packed four per word.
 *	The record is terminated by a newline.
 */
$(	LET CH=?
	FOR I=0 TO SIZE DO
		$(	CH := GETBYTE(V, I)
			WRCH(CH)
		$)
	IF CH\='*N' WRCH('*N')
$)

LET READREC(V) = VALOF
/*	Read the next logical record from the CIS, segmenting at
 *	MAXSTRLENGTH if necessary.  Pack the characters at BYTESPERWORD
 *	in V!0 onwards.  The result is the number of characters read,
 *	positive if the line was read to completion, negative if any
 *	characters remain.  The result is -1 if the CIS is exhausted.
 */
$(	LET N=0
	AND CH=?

	FOR I=0 TO MAXSTRLENGTH DO					// MAXSTRLENGTH seems to be a useful record limit...
		$(	CH := RDCH()
			IF CH=ENDSTREAMCH BREAK
			N := I
			PUTBYTE(V, N, CH)
			IF CH='*N' BREAK
		$)
	IF N=0 & CH=ENDSTREAMCH RESULTIS ENDSTREAMCH
	RESULTIS N=MAXSTRLENGTH & CH\='*N' -> -N, N
$)

LET DELETEOBJ(ONAME) BE RETURN

LET UNLOADSEG(ADDR) BE RETURN					// ...why also an UNLOAD()?

LET LOADSEG(SEG) = TRUE							// ...and a LOAD()?

LET GLOBIN(ADDR) = TRUE							// This might load the GLOBAL vector with entries from a newly-loaded SEGment...

