// $Id: LIBHDR,v 1.7 2013/01/29 17:31:40 rn Exp $

EXTERNAL $(
	fwritef
$)

//  libhdr
GLOBAL $(
start			: 1		// start(argv, argc)
sys				: 2
abort			: 3		// abort(error_code)	- calls backtrace() and mapstore()
backtrace		: 4
stacktrace		: 4		// stacktrace()			- summarise the run-time stack
trap			: 5		// trap(n)				- run diagnostics on call of first n undefined globals

selectinput		: 11	// selectinput(stream_id)
selectoutput	: 12	// selectoutput(stream_id)
blib_rdch		: 13	// ch := rdch()
blib_wrch		: 14	// wrch(ch)
unrdch			: 15	// unrdch()
blib_input		: 16
input			: 16	// stream_id := input()
blib_output		: 17
output			: 17	// stream_id := output()

timeofday		: 27	// str := timeofday()
time			: 28	// str := time()
date			: 29	// str := date()
stop			: 30	// stop(exit_code)
level			: 31	// stack_pointer := level()
longjump		: 32	// longjump(stack_pointer, label)
rewind			: 35	// rewind()

aptovec			: 40	// result := aptovec(function, vec_size)
blib_findoutput	: 41
findoutput		: 41	// stream_id := findoutput(filename)
blib_findinput	: 42
findinput		: 42	// stream_id := findinput(filename)
findappend		: 43	// stream_id := findappend(filename)
blib_endstream	: 45	// endstream(stream_id)
blib_endread	: 46	// endread()
blib_endwrite	: 47	// endwrite()
filetable		: 48	// address of filetable - for diagnostics: 24-oct-2012
rename			: 49	// result := rename(filename1, filename2)
delete			: 50	// result := delete(filename)
endtoinput		: 51	// endtoinput()
getenv			: 52	// str := getenv(envvar_name)
pathfindinput	: 53	// stream := pathfindinput(filename)
findfile		: 54	// stream := findfile(filename, mode)
fseek			: 55	// result = fseek(stream_id, character_posn)

blib_writes		: 60	// writes(string)
blib_writen		: 62	// writen(number)
newline			: 63	// newline()
newpage			: 64	// newpage()
blib_packstring		: 66	// char_length := packstring(vector, string)
blib_unpackstring	: 67	// unpackstring(string, vector)
blib_writed		: 68	// writed(number, width)
blib_readn		: 70	// number := readn()
terminator		: 71	// last byte read by readn()

capitalch		: 74	// ch := capitalch(ch)
blib_writehex	: 75	// writehex(number, width)
blib_writef		: 76	// writef(format_string, arg1, arg2, ..., arg11)
blib_writeoct	: 77	// writeoct(number, width)
mapstore		: 78	// mapstore()
blib_swritef	: 79	// swritef(string, format_string, arg1, arg2, ..., arg11)

getbyte			: 85	// ch := getbyte(string, character_offset)
putbyte			: 86	// putbyte(string, character_offset, ch)
blib_getvec		: 87	// vec_address := getvec(word_size)
blib_freevec	: 88	// freevec(vec_address)

rdargs			: 90	// rdargs(ignored, v, n)
result2			: 91	// various secondary results
strcat			: 92	// string := strcat(dest_string, srce_string)
str2no			: 93	// number := str2no(string)
str2numb		: 94	// str2numb(string, number)
stackbase		: 95	// base of runtime stack
stackend		: 96	// end of runtime stack
argc			: 97	// argument (parameter) count
argv			: 98	// argument (parameter) vectors
param			: 99	// argv!1 or ""
$)


MANIFEST $(
sysin		= 0
sysout		= 1
syserr		= 2				// Standard input, output and error streams (preopened, set to console)

endstreamch	= -1
bytesperword= 4
bitsperword	= 32
maxstrlength= 255
maxint		= #X7FFFFFFF
minint		= #X80000000

neggsz		= 32			// limit of negative GLOBAL numbers
firstfreeglobal	= 100
ug = firstfreeglobal
$)
