// Standard MCPL header

MANIFEST
  B2Wsh=2   // for a 32 bit implementation
//B2Wsh=3   // for a 64 bit implementation

GLOBAL

globsize:0,    // the size of the global vector


start:1,       //        start()
sys:2,         // res := sys(op,...)
abort:3,       //        abort(code, arg)
backtrace:4,   //
stacktrace:4,  //
trap:5,

selectinput:11,//        selectinput(scb)
selectoutput:12,//       selectoutput(scb)
rdch:13,       // ch  := rdch()
wrch:14,       //        wrch(ch)
unrdch:15,     // res := unrdch()
input:16,      // scb := input()
output:17,     // scb := output()
 
timeofday:27,  // tm  := timeofday()
time:28,       //        time()
date:29,       //        date()
stop:30,       //        stop(arg)

rewind:35,     //        rewind()

findoutput:41, // scb := findoutput("fname")
findinput:42,  // scb := findinput("fname")
findappend:43, // scb := findappend("fname")
endstream:45,  //        endstream(fcb)
endread:46,    //        endread(fcb)
endwrite:47,   //        endwrite(fcb)
filetable:48,							// for diagnostics: 24-oct-2012
rename:49,     // res := rename(name1, name2)
delete:50,     // res := delete(name)
endtoinput:51, //        endtoinput(fcb)
getenv:52,
pathfindinput:53,  // scb := pathfidinput(name, pathname)
findfile:54,   // scb := findfile("fname")

writes:60,     //        writes(str)
writen:62,
newline:63,    //        newline()
newpage:64,    //        newpage()

writed:68,     //        writed(n, d)
readn:70,      // n   := readn()

capitalch:74,  // ch  := capitalch(ch)
writehex:75,   //        writehex(n, d)
writef:76,     //        writef(format, a,...)
writeoct:77,   //        writeoct(n, d)
mapstore:78,

getbyte:85,
putbyte:86,
getvec:87,     // v   := getvec(upb)
freevec:88,    //        freevec(v)

rdargs:90,     // res := rdargs(keys, v, upb)
result2:91,
strcat:92,
str2no:93,
str2numb:94,   // n   := str2numb(string)
stackbase:95,
stackend:96,
argc:97,
argv:98,
param:99

// Globals 133-149 are defined in CLIHDR

MANIFEST
  Endstreamch    = -1,
  Bytesperword   = 1<<B2Wsh,
  Bpw            = Bytesperword,
  Bitsperbyte    = 8,
  Bitsperword    = Bitsperbyte*Bpw,
  Minint         = 1<<(Bitsperword-1),  // = #x80....0
  Maxint         = Minint-1,            // = #x7F....F

  Mcaddrinc      = Bpw,
  Ug             = 200,

  T_hunk         =  1000,
  T_end          =  1002,

  Co_pptr        = 0,
  Co_parent      = 1,
  Co_list        = 2,
  Co_fn          = 3,
  Co_size        = 4,

// rootnode offsets
  Rtn_membase    =     0,
  Rtn_memsize    =     1,
  Rtn_blklist    =     2,
  Rtn_tallyv     =     3,
  Rtn_msyslib    =     4,
  Rtn_mlib       =     5,
  Rtn_mboot      =     6,
  Rtn_mcli       =     7,
  Rtn_keyboard   =     8,
  Rtn_screen     =     9,
  Rtn_upb        =    20,

  Initobj = 0  // Position of the Init method in every class




